// ===========================================================================
//	CGeneralDialog.h		1995-97 Timo Eloranta		All rights reserved.
// ===========================================================================

#pragma once

#include <LGADialogBox.h>
#include <URegistrar.h>

#include "MyStructs.h"

class LCaption;
class LGAEditField;
class LGAPushButton;

class CAGASlider;

class CGeneralDialog : public LGADialogBox {
public:
	enum {
		class_ID = 'GDlg'
	};

			CGeneralDialog ( LStream *theStream );

	virtual ~CGeneralDialog() {};

	void	InitDialog();
	
	void	ListenToMessage( MessageT inMessage, void *ioParam );

	void	SetValues( SGeneral &inGeneral );
	void	GetValues( SGeneral &outGeneral );

	virtual void		FindCommandStatus(CommandT inCommand,
							Boolean &outEnabled, Boolean &outUsesMark,
							Char16 &outMark, Str255 outName);

private:

	LGAEditField	* mTicksEdit;

	CAGASlider		* mPopSlider;
	LCaption		* mPopCapt;
	
	CAGASlider		* mGridSlider;
	LCaption		* mGridCapt;
	
	LGAPushButton	* mFactoryButton;
	
	void	AdjustFactoryButton( );
	void	SetGridValue( Int16 inValue );
	void	SetDefaultValues();
};

