// ===========================================================================
//	CGraphWindow.h		1995-97 Timo Eloranta		All rights reserved.
// ===========================================================================
//	CGraphWindow.cp		(press Command-Tab to open the associated source file)

#pragma once

#include <LWindow.h>
#include <LCaption.h>
#include <URegistrar.h>

#include "CGraphPane.h"
#include "CPopulation.h"

class	CGraphGAApp;

class	CGraphWindow : public LWindow {

public:
	enum { class_ID = 'GrWi' };
	
						CGraphWindow(LStream *inStream);

		virtual void	DoSetZoom(Boolean inZoomToStdState);
	
		CGraphPane*		GetGraphPane() 
							{ return mGraphPane; };
							
		void			ResetSuperCommanderToApp();
	
		void			UpdateGraphInfo( CPopulation *inPop = nil );
		void			UpdatePopInfo(	Boolean inPopSizeToo = false,
										CPopulation *inPop = nil );
		void			UpdateIterStateInfo( EIterState inIterState 
												= iter_NoGraph );
		void			UpdateBestInfo( Boolean inBestHasChanged,
										CPopulation *inPop = nil );
										
private:
	CGraphGAApp		* mApp;			// The app which owns this window!
	CGraphPane		* mGraphPane;	// The pane that shows the best graph...

	LCaption		* mPopSizeCapt;
	LCaption		* mCurGenerCapt;
	LCaption		* mRunningCapt;
	LCaption		* mLeastCapt;
	LCaption		* mAverageCapt;
	LCaption		* mIterCapt;
	LCaption		* mFitnessCapt;
	LCaption		* mBestGenCapt;
	LCaption		* mNoGenCapt;
	LCaption		* mNoTimeCapt;

protected:
	virtual void	FinishCreateSelf();
};
