// ===========================================================================
//	CSelectionDialog.h		1995-97 Timo Eloranta		All rights reserved.
// ===========================================================================

#pragma once

#include <LGADialogBox.h>
#include <URegistrar.h>

#include "MyStructs.h"

class LCaption;
class LGAPushButton;
class LGACheckbox;
class LGARadioButton;

class CAGASlider;

class CSelectionDialog : public LGADialogBox {
public:
	enum {
		class_ID = 'SDlg'
	};

			CSelectionDialog ( LStream *theStream );

	virtual ~CSelectionDialog() {};

	void	InitDialog();
	
	void	ListenToMessage( MessageT inMessage, void *ioParam );

	void	SetValues( SSelection &inSelection, Int16 inPopSize );
	void	GetValues( SSelection &outSelection );

	virtual void		FindCommandStatus(CommandT inCommand,
							Boolean &outEnabled, Boolean &outUsesMark,
							Char16 &outMark, Str255 outName);

private:
	
	Int16			  mPopSize;
	
	LCaption		* mStepCapt;
	CAGASlider		* mStepSlider;
	LGARadioButton	* mAutomatic;
	LGARadioButton	* mManual;

	LCaption		* mMinCapt;
	CAGASlider		* mMinSlider;
	
	LGACheckbox		* mElitismBox;
	LGAPushButton	* mFactoryButton;
	
	void	AdjustFactoryButton( );
};

