// ===========================================================================
//	CTerminationDialog.h	1995-97 Timo Eloranta		All rights reserved.
// ===========================================================================

#pragma once

#include <LGADialogBox.h>
#include <URegistrar.h>

#include "MyStructs.h"

class LGAEditField;
class LGAPushButton;
class LGACheckbox;

class CTerminationDialog : public LGADialogBox {
public:
	enum {
		class_ID = 'TDlg'
	};

			CTerminationDialog ( LStream *theStream );

	virtual ~CTerminationDialog() {};

	void	InitDialog();
	
	void	ListenToMessage( MessageT inMessage, void *ioParam );

	void	SetValues( STermination &inTermination );
	void	GetValues( STermination &outTermination );

	virtual void		FindCommandStatus(CommandT inCommand,
							Boolean &outEnabled, Boolean &outUsesMark,
							Char16 &outMark, Str255 outName);

private:
	
	LGAEditField	* mMaxGenEdit;
	LGAEditField	* mMaxGenNoEdit;
	LGAEditField	* mMaxTimeEdit;
	LGAEditField	* mMaxTimeNoEdit;
	
	LGACheckbox		* mMaxGenBox;
	LGACheckbox		* mMaxGenNoBox;
	LGACheckbox		* mMaxTimeBox;
	LGACheckbox		* mMaxTimeNoBox;
	LGACheckbox		* mCrossingsBox;

	LGAPushButton	* mFactoryButton;
	
	void	AdjustFactoryButton();
	void	SetDefaultValues();
};

