// ===========================================================================
//	MyStructs.h		1995-97 Timo Eloranta					All rights reserved.
// ===========================================================================

#pragma once

#include <PP_Types.h>
#include <iterator.h>	// MSL

enum	EIterState {
	iter_NoGraph,
	iter_ReadyToGo,
	iter_Running,
	iter_Paused,
	iter_Walking,
	iter_Finished
};

struct	SGraphSize {
	Int16	nodes,
			edges;
};

struct	SNodePair {
	Int16	nodeNbr1,
			nodeNbr2;
};

null_template
struct iterator_trait <const SNodePair*> {
    typedef ptrdiff_t                    distance_type;
    typedef const SNodePair              value_type;
    typedef random_access_iterator_tag   iterator_category;
};

struct	STermination {
	Int32	maxGenTotal,
			maxGenNoChange,
			maxTimeTotal,
			maxTimeNoChange;
	Boolean	stopMaxGenTotal,
			stopMaxGenNoChange,
			stopMaxTimeTotal,
			stopMaxTimeNoChange,
			stopNoCrossings;
};

struct	SSelection {
	Int16	step,		// A parameter used in linear normalization
			min;		// A parameter used in linear normalization
	Boolean autom,		// Should the selection step be calculated by the program?
			elitism;	// Should the selection process be elitistic?
};

struct	SGeneral {
	Int16	sizeGrid,
			sizePop,
			spendTime;
};

struct	SEvaluation {
	Boolean crossingsRule;
	Int16	multip1,
			multip2,
			multip3,
			multip4,
			multip5,
			multip6,
			multip7;
};
			